// Code generated by protoc-gen-go-client. DO NOT EDIT.
// Sources: sync.proto

package client

import (
	fmt "fmt"
	reflect "reflect"
	strings "strings"

	servicehub "github.com/erda-project/erda-infra/base/servicehub"
	grpc "github.com/erda-project/erda-infra/pkg/transport/grpc"
	pb "github.com/erda-project/erda-proto-go/dop/issue/sync/pb"
	grpc1 "google.golang.org/grpc"
)

var dependencies = []string{
	"grpc-client@erda.dop.issue.sync",
	"grpc-client",
}

// +provider
type provider struct {
	client Client
}

func (p *provider) Init(ctx servicehub.Context) error {
	var conn grpc.ClientConnInterface
	for _, dep := range dependencies {
		c, ok := ctx.Service(dep).(grpc.ClientConnInterface)
		if ok {
			conn = c
			break
		}
	}
	if conn == nil {
		return fmt.Errorf("not found connector in (%s)", strings.Join(dependencies, ", "))
	}
	p.client = New(conn)
	return nil
}

var (
	clientsType                = reflect.TypeOf((*Client)(nil)).Elem()
	issueSyncServiceClientType = reflect.TypeOf((*pb.IssueSyncServiceClient)(nil)).Elem()
	issueSyncServiceServerType = reflect.TypeOf((*pb.IssueSyncServiceServer)(nil)).Elem()
)

func (p *provider) Provide(ctx servicehub.DependencyContext, args ...interface{}) interface{} {
	var opts []grpc1.CallOption
	for _, arg := range args {
		if opt, ok := arg.(grpc1.CallOption); ok {
			opts = append(opts, opt)
		}
	}
	switch ctx.Service() {
	case "erda.dop.issue.sync-client":
		return p.client
	case "erda.dop.issue.sync.IssueSyncService":
		return &issueSyncServiceWrapper{client: p.client.IssueSyncService(), opts: opts}
	case "erda.dop.issue.sync.IssueSyncService.client":
		return p.client.IssueSyncService()
	}
	switch ctx.Type() {
	case clientsType:
		return p.client
	case issueSyncServiceClientType:
		return p.client.IssueSyncService()
	case issueSyncServiceServerType:
		return &issueSyncServiceWrapper{client: p.client.IssueSyncService(), opts: opts}
	}
	return p
}

func init() {
	servicehub.Register("erda.dop.issue.sync-client", &servicehub.Spec{
		Services: []string{
			"erda.dop.issue.sync.IssueSyncService",
			"erda.dop.issue.sync.IssueSyncService.client",
			"erda.dop.issue.sync-client",
		},
		Types: []reflect.Type{
			clientsType,
			// client types
			issueSyncServiceClientType,
			// server types
			issueSyncServiceServerType,
		},
		OptionalDependencies: dependencies,
		Creator: func() servicehub.Provider {
			return &provider{}
		},
	})
}
